// This is -*- C++ -*-
// $Id: pooled.cpp,v 1.5 1998/12/15 20:56:19 trow Exp $

/* pooled.cpp
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <config.h>
#include <iostream>
#include "RealSet.h"

using namespace std;

int main()
{
  RealSet a,b,c;

  for(int i=0; i<10; ++i) {
    a.add(i);
    b.add(2*i);
    b.add(i*i);
  }
  c = a;
  c.append(b);
  
  cout << "   Appended mean: " << c.mean() << endl;
  cout << "Pooled mean a(b): " << a.pooled_mean(b) << endl;
  cout << "Pooled mean b(a): " << b.pooled_mean(a) << endl;

  cout << endl;

  cout << "    Appended var: " << c.var() << endl;
  cout << " Pooled var a(b): " << a.pooled_var(b) << endl;
  cout << " Pooled var b(a): " << b.pooled_var(a) << endl;
  return 0;
}


// $Id: pooled.cpp,v 1.5 1998/12/15 20:56:19 trow Exp $
