// This is -*- C++ -*-
// $Id: StringSet.h,v 1.2 1998/12/30 02:21:46 trow Exp $

/* 
 * StringSet.h
 *
 * Copyright (C) 1998 Asger Alstrup Nielsen
 *
 * Developed by Asger Alstrup Nielsen <alstrup@diku.dk>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef _INC_STRINGSET_H
#define _INC_STRINGSET_H

#include <iostream>
#include "DataSet.h"
#include "DataType.h"

class StringSet : public DataSet {
public:
  StringSet() : DataSet(new StringType()) { }
  StringSet(StringSet const & s) : DataSet(s) { data_ = s.data_; }
  ~StringSet() { }
  StringSet& operator=(StringSet const & s);
  // Access only
  Value const * operator[](size_t i) const;
  bool empty() const;
  size_t size() const;
  void reserve(size_t N);
  void push_back(Value const & v);
  void insert(size_t position, Value const & v);
  void pop_back();
  void erase(size_t position);
  void erase(size_t first, size_t last);
  void clear();
  Permutation sorting_permutation(int dir = 1) const;
  void permute(Permutation const &);
  void spew(ostream& out, char sep = ' ') const;

  // Special accessors to the concrete representation
  typedef vector<string> representation;
  representation & strings();
  representation const & strings() const;
private:
  representation data_;
};

#endif
