// This is -*- C++ -*-
// $Id: bootstrap.h,v 1.8 1998/12/31 03:29:41 trow Exp $


/* bootstrap.h
 *
 * Copyright (C) 1998 EMC Capital Management, Inc.
 *
 * Developed by Jon Trowbridge <trow@emccta.com>.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef _INC_BOOTSTRAP_H
#define _INC_BOOTSTRAP_H

#include "RealSet.h"

RealSet bootstrap_mean(size_t, const RealSet&, int threads=1);
RealSet bootstrap_median(size_t, const RealSet&, int threads=1);
RealSet bootstrap_sdev(size_t, const RealSet&, int threads=1);

void bootstrap_linreg_pairs(size_t, const RealSet& x, const RealSet& y,
			    RealSet& slope, RealSet& inter, RealSet& r);

#endif // _INC_BOOTSTRAP_H

// $Id: bootstrap.h,v 1.8 1998/12/31 03:29:41 trow Exp $
