// This is -*- C++ -*-
// $Id: test_H001.cpp,v 1.1 1999/01/20 21:10:49 trow Exp $

#include <iostream>
#include <time.h>
#include <Random.h>
#include <RealSet.h>
#include <bootstrap.h>

main()
{
  Random rnd;
  RealSet data;
  for(size_t i=0; i<500; ++i)
    data.add(rnd.random_normal(0.0, 1.0));
  
  size_t iter = 1000;
  time_t t1=0, t2=0;

  cout << "Searching for non-trivial iteration count:" << endl;
  cout << "(The faster your CPU, the more iterations we need to do in order" << endl;
  cout << "for the computation to take long enough for us to measure properly.)" << endl;
  // First, find a non-trivial iteration amount:
  while (t2 - t1 < 2) {
    cout << iter << " ";
    cout.flush();
    time(&t1);
    bootstrap_mean(iter, data);
    time(&t2);
    iter *= 2;
  }
  cout << endl << endl;
  iter *= 3;

  for (int t=1; t<5; ++t) {
    cout << "threads=" << t << " --> ";
    cout.flush();

    time(&t1);
    RealSet boot1 = bootstrap_mean(iter, data, t);
    time(&t2);

    cout << iter << " iterations in " << t2-t1 << " seconds." << endl;
  }
}


// $Id: test_H001.cpp,v 1.1 1999/01/20 21:10:49 trow Exp $
